%This function returns nonquadratic tranformations of data for the FastICA
%landscape program.
%Neil Gadhok, v1.0, November 16, 2004

function result = Gfunctions(y,G)

switch G
case {1}, %G1 = (1/a1)*log(cosh(a1*y));
    a1 = 1; % 1 <= a1 <= 2, p.184, HyK001
    result = (1/a1).*log(cosh(a1.*y));
case {2}, %G2 = - exp(-(y.^2))./2)
    result = - exp(-(y.^2)./2);
case {3}, %G3 = (y.^4)/4
    result = (y.^4)./4;
case {4}, %G4 = {y.^3)
    result = (y.^3);
otherwise
    warning('invalid selection');
    result = 0;
end


