%This file calculates the Radical ICA objective function landscape.
%Neil Gadhok, v1.0, November 30, 2004.
function [H] = Radical_Cntrst(x,W)
%We want to minimize the entropy.

%The Radical ICA algorithm uses an altered spacing estimates of entropy by Vasicek and
% an exhaustive rotation search in order to solve the BSS problem. The objective is to 
%minimize the entropy by searching through different rotations.

%[MiFi03] E. Learned-Miller and J. Fishher III, "ICA Using Spacing estimates of
%entropy", J. of Machine Learning Research, vol. 4, pp. 1271-1295, 2003.

   y = W*x;
   
   [m,n] = size(y);   
   %Calculate m-spacing entropy
   H = 0;
   for j = 1:m,
       %This is what is implemented in Radical ICA program
       %It is Eqn 8, but with the constants 1/N-m and N+1/m removed.
        %len=length(y(j,:));
        %vals=sort(y(j,:));
        %intvals=vals(mN+1:len)-vals(1:len-mN);
        %hvec=log(intvals);
        %H(index) = H(index) + sum(hvec);

        %This is what the RadicalICA paper says to implement. 
        %Eq. 8 [MiFi03]
         H = H + Radical_Vasicek(y(j,:));
   end
        
               
